import socket
import time, datetime
import os
import re
from threading import Thread


class myProc(Thread):
  def __init__(self, hostip, hostport, cmd, new_line = True, sleeptime = 0):
    self.cmdline = cmd
    self.newline = new_line
    self.sleep = sleeptime
    self.host = hostip
    self.port = hostport
    Thread.__init__(self)

  def run(self):
    promptre =re.compile('.*\$\>.$')
    data = ""
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.connect((self.host, self.port))
    s.recv(1024)
    for cmd in self.cmdline:
      if (cmd == 'quit'): break
      if self.newline: cmd += '\r\n'
      s.send(cmd)
      time.sleep(int(self.sleep))

      found = False
      while (found == False):
        temp = s.recv(1024)
        lines = temp.split('\n')
        for line in lines:
          if (promptre.match(line)):
            found = True
          data += temp

    s.send('quit\r\n')
    s.close()
    return data

class TestAgentCE:
  host = '192.168.1.110'
  port = 27020
  debug = 2


  def sendCMD(self, cmdline, newline = True, sleep = 0):
    promptre = re.compile('.*\$\>.$')

    #TODO: any commands that don't output anything and quit need to match this RE
    pushre = re.compile('^push .*$')
    data = ""
    noQuit = False
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.connect((self.host, self.port))
    s.recv(1024)
    for cmd in cmdline:
      if (cmd == 'quit'): break
      if newline: cmd += '\r\n'
      s.send(cmd)
      time.sleep(int(sleep))
      if (pushre.match(cmd)):
        noQuit = True
      elif noQuit == False:
        found = False
        while (found == False):
          if (self.debug >= 3): print "recv'ing..."
          temp = s.recv(1024)
          lines = temp.split('\n')
          for line in lines:
            if (promptre.match(line)):
              found = True
          data += temp

    if (noQuit == False):
      s.send('quit\r\n')
    s.close()
    return data
  
  
  #take a data blob and strip instances of the prompt '$>\x00'
  def stripPrompt(self, data):
    promptre = re.compile('.*\$\>.*')
    retVal = []
    lines = data.split('\n')
    for line in lines:
      try:
        while (promptre.match(line)):
          pieces = line.split('\x00')
          index = pieces.index("$>")
          pieces.pop(index)
          line = '\x00'.join(pieces)
      except(ValueError):
        pass
      retVal.append(line)

    return '\n'.join(retVal)
  

  def pushFile(self, localname, destname):
    self.mkDirs(destname)
    if (self.debug >= 2): print "sending: push " + destname
    f = open(localname, 'rb')
    data = f.read()
    f.close()
    self.sendCMD(['push ' + destname + '\r\n', data], newline = False)
  
  
  def mkDir(self, name):
    self.sendCMD(['mkdr ' + name, 'quit'])
  
  
  #make directory structure on the device
  def mkDirs(self, filename):
    parts = filename.split('\\')
    name = ""
    for part in parts:
      if (part == parts[-1]): break
      if (part != ""):
        name += "\\" + part
        self.mkDir(name)


  #push localDir from host to remoteDir on the device
  def pushDir(self, localDir, remoteDir):
    if (self.debug >= 2): print "pushing directory: " + localDir + " to " + remoteDir
    for root, dirs, files in os.walk(localDir):
      parts = root.split(localDir)
      for file in files:
        self.pushFile(root + "\\" + file, remoteDir + '\\' + parts[1] + '\\' + file)


  def dirExists(self, dirname):
    match = ".*" + dirname.replace('\\', '\\\\') + "$"
    dirre = re.compile(match)
    data = self.sendCMD(['cd ' + dirname, 'cwd', 'quit'], sleep = 1)
    retVal = self.stripPrompt(data)
    data = retVal.split('\n')
    found = False
    for d in data:
      if (dirre.match(d)): 
        found = True

    return found


  #list files on the device, requires cd to directory first
  def listFiles(self, rootdir):
    if (self.dirExists(rootdir) == False): return []  
    data = self.sendCMD(['cd ' + rootdir, 'ls', 'quit'], sleep = 3)
    retVal = self.stripPrompt(data)
    return retVal.split('\n')


  def removeFile(self, filename):
    if (self.debug>= 2): print "removing file: " + filename
    self.sendCMD(['rm ' + filename, 'quit'])
  
  
  #does a recursive delete of directory on the device: rm -Rf remoteDir
  def removeDir(self, remoteDir):
    filelist = self.listFiles(remoteDir)
  
    #TODO: logic is way too simple and basic, make more robust
    isFile = re.compile('^([a-zA-Z0-9_\-\. ]+)\.([a-zA-Z0-9]+)$')
    for f in filelist:
      if (isFile.match(f)):
        self.removeFile(remoteDir + "\\" + f)
      else:
        self.removeDir(remoteDir + "\\" + f)

    if (self.debug >= 3): print "removing: " + remoteDir
    self.sendCMD(['rmdr ' + remoteDir, 'rm ' + remoteDir, 'quit'], sleep = 1)


  def getProcessList(self):
    data = self.sendCMD(['ps', 'quit'], sleep = 3)
    retVal = self.stripPrompt(data)
    lines = retVal.split('\n')
    files = []
    for line in lines:
      if (line.strip() != ''):
        pidproc = line.strip().split(' ')
        if (len(pidproc) == 2):
          files += [[pidproc[0], pidproc[1]]]
      
    return files


  def getMemInfo(self):
    data = self.sendCMD(['mems', 'quit'])
    retVal = self.stripPrompt(data)
    #TODO: this is hardcoded for now
    fhandle = open("memlog.txt", 'a')
    fhandle.write("\n")
    fhandle.write(retVal)
    fhandle.close()

  def fireProcess(self, appname):
    self.process = myProc(self.host, self.port, ['exec ' + appname, 'quit'])
    self.process.start()  

  #iterates process list and returns pid if exists, otherwise ''
  def processExist(self, appname):
    pid = ''
  
    pieces = appname.split('\\')
    app = pieces[-1]
    procre = re.compile('.*' + app + '.*')
  
    procList = self.getProcessList()
    for proc in procList:
      if (procre.match(proc[1])):
        pid = proc[0]
        break
    return pid


  def killProcess(self, appname):
    pid = self.processExist(appname)
    if (pid != ''):
      self.sendCMD(['kill ' + pid, 'quit'])
      return True
    return False


  def getTempDir(self):
    promptre = re.compile('.*\$\>\x00.*')
    retVal = ''
    data = self.sendCMD(['tmpd', 'quit'])
    return self.stripPrompt(data)

  
  #copy file from device (remoteFile) to host (localFile)
  def getFile(self, remoteFile, localFile):
    promptre = re.compile('.*\$\>\x00.*')
    data = self.sendCMD(['cat ' + remoteFile, 'quit'], sleep = 5)
    retVal = self.stripPrompt(data)
    fhandle = open(localFile, 'wb')
    fhandle.write(retVal)
    fhandle.close()
  
  
  #copy directory structure from device (remoteDir) to host (localDir)
  def getDirectory(self, remoteDir, localDir):
    if (self.debug >= 2): print "getting files in '" + remoteDir + "'"
    filelist = self.listFiles(remoteDir)
    if (self.debug >= 3): print filelist
    if not os.path.exists(localDir):
      os.makedirs(localDir)
  
    #TODO: is this a comprehensive file regex?
    isFile = re.compile('^([a-zA-Z0-9_\-\. ]+)\.([a-zA-Z0-9]+)$')
    for f in filelist:
      if (isFile.match(f)):
        self.getFile(remoteDir + "\\" + f, os.path.join(localDir, f))
      else:
        self.getDirectory(remoteDir + "\\" + f, os.path.join(localDir, f))

  
