import os, re, maemkit

class ChromeDriver(maemkit.MaemKit):
  options = {}
  mochitestCommand = []
  directories = []

  def __init__(self, mkit, testname="chrome"):
    self.dirtype = mkit.dirtype
    self.addOptions(mkit.config_options[testname])
    self.testname = testname
    if (self.testname == "browser-chrome"):
        self.testdir = "browser"
    else:
        self.testdir = "chrome"

  def addOptions(self, input):
    for option in input: self.options[option] = input[option]
    #TODO: figure out if we are doing a splitdirs here (might be required for wince or symbian)
    #TODO: figure out if we are going to support a test-path for chrome
    self.options["backupdir"] = os.path.normpath(os.path.join(self.options["testroot"], self.options["backupdir"]))

  def getTests(self):
    myre = re.compile(".*([a-zA-Z0-9\-\_]+).*")
    testdirectory = os.path.normpath(os.path.join(self.options["testroot"], self.testdir))
    for dir in os.listdir(testdirectory):
      if (myre.match(dir)): self.directories.append(dir)

    self.directories.sort()

  def prepTests(self):
    #TODO: figure out a method for setting these user_pref in the profile (automation.py?)
    #set user_pref("browser.sessionhistory.max_total_viewers", -1)
    #set user_pref("dom.storage.default_quota", 640)
    self.directories = self.splitListParallel(self.directories, self.options)

  def runTests(self):
    self.mkLogDir(self.options["logdir"])

    #TODO: this block is the same as MochiDriver except for the --chrome flag
    #TODO: figure out a method for utilizing all the other config/cli options available
    cmd = os.path.normpath(os.path.join(self.options["testroot"], "runtests.py"))
    self.mochitestCommand = ["python " + cmd + " --autorun --close-when-done --%s" % self.testname]
    for option in ["utility-path","appname","xre-path","certificate-path"]:
      self.mochitestCommand.append("--" + option + "=" + os.path.normpath(self.options[option]))
    mCommand = " ".join(self.mochitestCommand)

    if self.options["test-path"]:
      self.directories = [self.options["test-path"]]

    for directory in self.directories:
      logfile = os.path.normpath(os.path.join(self.options["logdir"],
                                 self.getLogFileName(directory)))
      self.addCommandSubClass("%s --log-file=%s --test-path=%s" % (mCommand, logfile, directory))
      if self.options['verbose'] and os.path.exists(logfile):
        print ''.join(open(logfile).readlines())

  def parseLogs(self):
    self.stitchLogs()

class BrowserChromeDriver(ChromeDriver):
  def __init__(self, mkit):
    ChromeDriver.__init__(self, mkit, testname="browser-chrome")
